#include <sys/socket.h>
#include <netinet/in.h>
#include <strings.h>

#include "main.h"
#include "ident.h"
#include "config.h"

char *ident_lookup(unsigned long rhost, unsigned short rport)
{
  char *rv=NULL;
  static char username[128]; /* any longer replies? i dont care.. */
  char buffer[128];
  int sock;
  int sock2;
  struct sockaddr_in addr;
  struct sockaddr_in addr2;
  int size=sizeof(struct sockaddr_in);

  bzero(username, sizeof(username));

  sock = socket(AF_INET, SOCK_STREAM, 0);
  sock2 = socket(AF_INET, SOCK_STREAM, 0);
  
  if ((sock < 0) || (sock2 < 0))
    {
      perror("ident:socket");
      return NULL;
    }

  /* Setup addresses */
  addr.sin_family = addr2.sin_family = AF_INET;
  addr.sin_addr.s_addr = addr2.sin_addr.s_addr = rhost;
  addr.sin_port = rport;
  addr2.sin_port = htons(IDENT_PORT);

  /* Check that IDENT_PORT is open.. */
  if (connect(sock2, (struct sockaddr *)&addr2, sizeof(struct sockaddr_in)))
    {  /* This means it was closed */
      options.ident=0; /* Dont bother trying again.. */
    }
  else 
    if (connect(sock, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)))
      perror("ident:connect");
    else
      if (getsockname(sock, (struct sockaddr *)&addr, &size))
	perror("getsockname");
      else
	{
	  char *temp;

	  snprintf(buffer, sizeof(buffer)-1, "%i, %i\n", ntohs(rport), ntohs(addr.sin_port));
	  send(sock2, buffer, strlen(buffer), 0);
	  recv(sock2, username, sizeof(username)-1, 0);
	  rv=rindex(username, ':')+1;
	  
	  if (rv)
	    {
	      temp=rindex(rv, '\n');
	      *--temp=0x0;
	    }
	}

#ifdef DEBUG
  printf("USER: %s\n", rv);
#endif

  close(sock);
  close(sock2);

  return rv;
}

