#include <stdio.h>
#include <string.h>
#include <resolv.h>
#include <stdlib.h>
#include <limits.h>

#include "input.h"
#include "main.h"
#include "resolve.h"
#include "signal.h"

#include <netinet/in.h>

int feedhost(void)
{
  static char buffer[MAXDNAME];

  bzero(buffer, sizeof(buffer));
  
  if (options.inputtype == I_FILE)
    {
      if (!feof(options.lamein))
	{
	  char *pt;
	  
	  fgets(buffer, sizeof(buffer)-1, options.lamein);
	  
	  if ((pt = rindex(buffer, '\n')) != NULL) *pt=0x0;
	}
      else
	return 0;
    }
  else
    if (options.inputtype == I_CMDLINE)
      {
	memcpy(buffer, options.cmdlinehost, strlen(options.cmdlinehost));
	if (options.info.count++ > 0)
	  options.feedstatus=0;
      }
    else
      if (options.inputtype == I_PROG_HOST) /* used popen() with fread() here to keep the code small.. */
	{
	  while (1)
	    {
	      auto int i=0;
	      
	      bzero(buffer, sizeof(buffer));
	      
	      do
		{
		  fread((char *)buffer+i, 1, 1, options.lamein);
		  if (feof(options.lamein))
		    { options.feedstatus=0; break; }
		}while((buffer[i] != '\n') && (i < MAXDNAME) && ++i);
	      
	      strtok(buffer, " ");
	      if (!strcmp(buffer, options.cmdlinehost)) continue;
	      
	      break;
	    }
	}
  
  options.host = lookup(buffer);

  return options.feedstatus;
}

int initport(char *ports)
{
  char *temp;
  int lower=0;
  int upper=0;
  int status;
  int count=0;
  

  void addport(unsigned short port) /* Local function */
    {
      if (!options.ports)
	{
	  options.ports = (struct portinfo *)malloc(sizeof(struct portinfo));
	  options.orgports = options.ports;
	}
      else
	{
	  options.ports->next=(struct portinfo *)malloc(sizeof(struct portinfo));
	  options.ports = options.ports->next;
	}
      options.ports->port = htons(port);
      options.ports->next=NULL;
      
      count++;
    }

  temp = ports;

  while (count < USHRT_MAX)
    {
      status = sscanf(temp, "%i:%i", &lower, &upper);
      if (status == 2)
	for (; lower <= upper; lower++)
	  addport(lower);
      else
	if (status == 1)
	  addport(lower);
      
      temp = index(temp, ',');
      if (!temp++) break;
    }
  
  options.ports=options.orgports;

  return count;
}

int feedport(void)
{
  if (options.ports->next)
    {
      options.ports=options.ports->next;
      return 1; /* continuing */
    }
  else
    options.ports=options.orgports;
      
  return 0; /* restarting */
}
