#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>

#define RANGE (options.end - options.start)

struct thread
{
  int thread;
  unsigned short spawned;
  pid_t pid;
  int shkey;
};

struct odata
{
  short locked;
};

struct portinfo
{
  unsigned short port;
  struct portinfo *next;
};

struct info
{
  unsigned long count; /* to count how many hosts we have scanned */
  unsigned short ports; /* nr of ports we have gotten (0 is a single port here) */
  time_t start;
};

struct options
{
  FILE *lamein;
  FILE *lameout;

  char *cmdlinehost;
  char *cmdlineport;
  unsigned long host;
  struct portinfo *ports;
  struct portinfo *orgports;

  unsigned long timeout; /* sec */
  unsigned short delay; /* sec */
  unsigned short start; /* start from this port */
  unsigned short end; /* scan up to this port */
  unsigned char verbose; /* level of verbosity */
  unsigned char inputtype;

  char *opencmd; /* command to run if port was open */
  char *closedcmd; /* command to run if port was closed */

  struct thread thread;
  struct odata *odata; /* the lockthingy for output */
  struct info info;

  /* Just some simple YES/NO options */
  unsigned random: 1;
  unsigned ansi: 1;
  unsigned nodefaultoutput: 1;
  unsigned dolookup: 1;
  unsigned feedstatus: 1;
  unsigned parent: 1;
  unsigned ident: 1;
  unsigned checkportverbose: 1;
  unsigned checkport: 1;
};

void exithandler(void);

extern struct options options;
