#include <netdb.h>
#include <netinet/in.h>
#include <signal.h>
#include <resolv.h>
#include <arpa/inet.h>
#include <string.h>

#include "resolve.h"
#include "main.h"
#include "getoptions.h"

extern void sigalrm(void);

/* Should i let this return the whole h_addr_list[] ? hmm.. maybe a cmdline option? :) */
unsigned long lookup(char *host)
{
  struct hostent *he;
  unsigned long addr;

  if ((!host) || (strlen(host) < 1)) return 0;

#ifdef DEBUG
  printf("lookup(%s)\n", host);
#endif

  he = gethostbyname(host);
  if (!he)
    return inet_addr(host);
  else
    {
      memcpy((char *)&addr, (char *)he->h_addr_list[0], sizeof(addr));
      return addr;
    }

  return -1;
}

char *revlookup(unsigned long host, unsigned char dolookup)
{
  struct hostent *he=NULL;
  static char buffer[MAXDNAME];
      
  if (dolookup)
    {
      he = gethostbyaddr((char *)&host, sizeof(host), AF_INET);
      if (he)
	{
	  strncpy(buffer, he->h_name, sizeof(buffer)-1);
	  return buffer;
	}
    }
  
  sprintf(buffer, "%s", inet_ntoa(*(struct in_addr *)&host));
  
  return buffer;
}
