#include <stdio.h>
#include <unistd.h>
#include <netinet/in.h>
#include <string.h>

#include "resolve.h"
#include "runcmd.h"
#include "main.h"
#include "ident.h"

/* This function can be bufferoverflowed.. fix in a later version..
   it doesn't matter until we add stealthscan functions and require
   suid root anyway... until then relax.. */
char *gencmd(unsigned long host, unsigned short port, char *command)
{
  static char buffer[GENCMD_BUFSIZE]; /* Who wants to run a longer cmd than this anyway? */
  int i;
  int ii;

  if (!command) return NULL;

#ifdef DEBUG
  fprintf(options.lameout, "ORG: %s\n", command);
#endif

  /* parse the commandline for % commandthingys */
  for (i=ii=0; (i < GENCMD_BUFSIZE) && (i < strlen(command));)
    switch(command[i])
      {
	char *temp;
	
      case '%':
	switch(command[i+1])
	  {
	  case '%':
	    buffer[ii]='%';
	    i+=2;
	    ii+=strlen(buffer+ii);
	    break;
	    
	  case 'h':
	    sprintf(buffer+ii, "%s", revlookup(host, 0));
	    i+=2;
	    ii+=strlen(buffer+ii);
	    break;

	  case 'H':
	    sprintf(buffer+ii, "%s", revlookup(host, 1));
	    i+=2;
	    ii+=strlen(buffer+ii);
	    break;

	  case 'p':
	    sprintf(buffer+ii, "%i", ntohs(port));
	    i+=2;
	    ii+=strlen(buffer+ii);
	    break;

	  case 'u':
	    temp=ident_lookup(host, port);
	    if (temp)
	      {
		sprintf(buffer+ii, "%s", temp);
		i+=2;
		ii+=strlen(buffer+ii);
	      }
	    else
	      i+=2;
	    break;
	  }

      default:
	buffer[ii++]=command[i++];
	break;
      }

#ifdef DEBUG  
  fprintf(options.lameout, "GEN: %s\n", buffer);
#endif

  return buffer;
}
