#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <netinet/in.h>

#include "main.h"
#include "output.h"
#include "scan.h"
#include "checkport.h"
#include "input.h"

/* Network byte order */
#define IS_HOST(x) ((x & 0xff000000) != 0)
#define IS_NETC(x) ((x & 0xff000000) == 0)
#define IS_NETB(x) ((x & 0xffff0000) == 0)
#define IS_NETA(x) ((x & 0xffffff00) == 0)
#define IS_NULL(x) (!x)
#define IS_FULL(x) (x == 0xffffffff)

int scan(unsigned long host, unsigned short port)
{
  if (IS_HOST(host) || IS_NULL(host) || IS_FULL(host))
    scan_host(host, port);
  else
    if (IS_NETA(host) || IS_NETB(host) || IS_NETC(host))
      scan_para(host, port);
  
  return 1;
}

int scan_set(unsigned long host, unsigned short port)
{
  int status;

  do
    {
      status = checkport(host, options.ports->port);
    }while(feedport());

  return 1;
}

/* scan bottom up, single host */
int scan_normal(unsigned long host, unsigned short port)
{
  int i=options.start;
  int status;

  if (!port) /* port == 0, scan all ports */
    {
      for (i=options.start; i <= options.end; i++)
	{
	  status = checkport(host, htons(i));
	}
    }
  else /* port specified, scan only this one */
    {
      status = checkport(host, port);
    }

  return 1;
}

/* scan random ports */
int scan_random(unsigned long host, unsigned short port)
{
  int count=0;
  int i;
  char check[RANGE+1];


  port=ntohs(port);
  srand(time(NULL));
  memset((char *)&check, 0, sizeof(check));
  if (options.start == 0) options.start++;

  while (count != (RANGE+1))
    {
      i = rand() % (RANGE+1);

      if (check[i] == 0 && (i+options.start!=0))
	{
	  checkport(host, htons(i + options.start));
	  check[i]=0x1;
	  count++;
	}
    }

  return 0;
}

/* scan range of hosts */
int scan_para(unsigned long net, unsigned short port)
{
  unsigned long count=0xff;

  if (IS_NETB(net)) count*=0xff;
  if (IS_NETA(net)) count*=0xff;
    
  while (1)
    {
      net+=0x01000000;
      count--;
      
      if ((net&0xff000000) == 0xff000000) { net=net&0x00ffffff; net+=0x00010000; }
      if ((net&0x00ff0000) == 0x00ff0000) { net=net&0x0000ffff; net+=0x00000100; }
      if ((net&0x0000ff00) == 0x0000ff00) { net=net&0x000000ff; net+=0x00000001; }

      if (count == 0) break;
  
      scan_host(net, port);
    }
  
  return 0;
}

int scan_host(unsigned long host, unsigned short port)
{
  if (options.random)
    scan_random(host, port);
  else if (options.info.ports > 1)
    scan_set(host, port);
  else
    scan_normal(host, port);
  
  
  return 1;
}
